var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react", "lodash"], function (require, exports, React, react_1, _) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function databind(event, ds, render) {
        return function () {
            return (React.createElement(Bound, { event: event, dataStore: ds, render: render }));
        };
    }
    exports.databind = databind;
    var Bound = (function (_super) {
        __extends(Bound, _super);
        function Bound(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {
                data: undefined,
                paging: undefined
            };
            // This needs to happen early
            props.event.call(props.dataStore, function (data, paging) {
                _this.setState({
                    data: data,
                    paging: paging
                });
            });
            return _this;
        }
        Bound.prototype.transition = function (args) {
            var currentParams = this.props.dataStore.getCurrentParameters();
            var newParams = _.extend({}, currentParams, args);
            if (args.facets) {
                newParams.facets = _.extend({}, currentParams.facets, args.facets);
            }
            // TODO - should handle different classes of route
            var page = (newParams.start || 0) / this.props.dataStore.getCoreConfig().pageSize + 1;
            var facets = '';
            if (newParams.facets) {
                facets = '?' + _.map(newParams.facets, function (k, v) { return v + '=' + (_.isArray(k) ? k.join(',') : k); }).join('&');
            }
            this.context.router.history.push('/' + this.props.dataStore.getCoreConfig().prefix + '/' + newParams.query + '/' +
                page + facets);
            this.props.dataStore.stateTransition(newParams);
        };
        Bound.prototype.getChildContext = function () {
            return {
                searchState: this.props.dataStore.getCurrentParameters(),
                transition: this.transition.bind(this)
            };
        };
        Bound.prototype.render = function () {
            // TODO these need to be named or something
            if (!this.state.data) {
                return null;
            }
            return (this.props.render(this.state.data || [], this.state.paging));
        };
        Bound.childContextTypes = {
            transition: react_1.PropTypes.func,
            searchState: react_1.PropTypes.object
        };
        Bound.contextTypes = {
            router: react_1.PropTypes.object
        };
        return Bound;
    }(React.Component));
    exports.Bound = Bound;
    var DataBind = (function (_super) {
        __extends(DataBind, _super);
        function DataBind() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DataBind.prototype.render = function () {
            return (React.createElement("div", null, this.props.children));
        };
        return DataBind;
    }(React.Component));
    exports.DataBind = DataBind;
});
//# sourceMappingURL=DataBinding.js.map